#ifndef csc_TrivialDetector_hh
#define csc_TrivialDetector_hh

#include "G4VUserDetectorConstruction.hh"


class G4VPhysicalVolume;


/**
 * The TrivialDetector class is used to define the materials and geometrical
 * setup of the detector to be simulated. It derives from 
 * G4VUserDetectorConstruction and belongs to one of the mandatory user
 * initialization classes. The virtual method "Construct()" must be overloaded.
 * It must return the physical volume of the simulation world.
 */
class TrivialDetector : public G4VUserDetectorConstruction
{

public:
  TrivialDetector();
  ~TrivialDetector();

  /**
   * Overloaded: This implementation defines the material and geometry
   * of the trivial example.
   */
  G4VPhysicalVolume* Construct();

};
#endif
