#ifndef TrivialPrimaryGenerator_h
#define TrivialPrimaryGenerator_h 1

/// Interface definition of the mandatory user action to generate primary particles.
#include "G4VUserPrimaryGeneratorAction.hh"

class G4ParticleGun;
class G4Event;

/**
 * The primary generator is a mandatory user action. It defines, at the beginning
 * of each simulation event, the inital properties of particles to be simulated.
 * In our case, the TrivialPrimaryGenerator will always define only one Geantino
 * and shoot it into a pre-defined direction. We will use the G4ParticleGun, a
 * helper class, which does the necessary registration work to get the particle
 * into the G4 event.
 */
class TrivialPrimaryGenerator : public G4VUserPrimaryGeneratorAction
{
public:
  TrivialPrimaryGenerator();
  ~TrivialPrimaryGenerator();
  
public:
  
  /// Overloaded: we implement this method in order to generate primary particles.
  void GeneratePrimaries(G4Event* anEvent);
  
private:

  /// Helper class provided by G4.
  G4ParticleGun* particleGun;
};

#endif


