
/*************************************************
* Simple Single Histogramm class for checks
* Usage: 
* test = new CalorimeterRootTree(); 
* test->BookHisto("Etot",0.08,0.12);
* test->FillHisto(totE / GeV);
*
*************************************************/
#define DEBUG
#include "CalorimeterRootTree.hh"
#include <TFile.h>
#include <TTree.h>


CalorimeterRootTree* CalorimeterRootTree::TheCalorimeterRootTree=0;

CalorimeterRootTree * CalorimeterRootTree::GetTreePointer(){
	if (!TheCalorimeterRootTree){
		TheCalorimeterRootTree = new CalorimeterRootTree();
		 cout <<" Root tree  " << endl;
	} 
	
	return TheCalorimeterRootTree; 
}


CalorimeterRootTree::CalorimeterRootTree(){
	std::cout << "*--- CalorimeterRootTree::Constructing ---* "<< std::endl;    
	
	m_rootfile =  new TFile("Calorimeter.root","RECREATE");
	m_roottree =  new TTree ();
	m_roottree->Branch("N_hit",&N_hit,"N_hit/I");

	m_roottree->Branch("e5x5",&m_e5x5,"e5x5/D");
	m_roottree->Branch("e3x3",&m_e3x3,"e3x3/D");
	m_roottree->Branch("e1x1",&m_e1x1,"e1x1/D");



}

CalorimeterRootTree::~CalorimeterRootTree(){
	
	
	
	m_roottree->Write();
	m_rootfile->Write();
	delete m_roottree;
	delete m_rootfile;
	
	std::cout << "*--- CalorimeterRootTree::Destructing ---*"<< std::endl;
}
