#include "SteppingAction.hh"
#include "G4SteppingManager.hh"
#include "G4Track.hh"
#include "G4Step.hh"
#include "G4StepPoint.hh"
#include "G4TrackStatus.hh"
#include "G4VPhysicalVolume.hh"
#include "G4ParticleDefinition.hh"
#include "G4ParticleTypes.hh"
#include "G4UnitsTable.hh"
SteppingAction::SteppingAction()
{;}

SteppingAction::~SteppingAction()
{;}

void SteppingAction::UserSteppingAction(const G4Step * theStep)
{
	G4Track * theTrack = theStep->GetTrack();
	// check if it is primary
	if(theTrack->GetParentID()!=0) { return; };
	
	//Print out diverse particle information
	G4cout << std::setw( 8) << "#Step#"     << "   "
	<< std::setw( 8) << "X"          << "   "
	<< std::setw( 8) << "Y"          << "   "  
	<< std::setw( 8) << "Z"          << "   "
	<< std::setw( 8) << "KineE"      << "   "
	<< std::setw( 8) << "dEStep"     << "   "  
	<< std::setw(8) << "StepLeng"   << "   "   
	<< std::setw(8) << "TrakLeng"   << "   "  
	<< std::setw(8) << "Process"    << G4endl;	        
	
	// Here you have to add the appropriate Geant4 commands
	// to obtain the information announced above ...
	G4cout << std::setw(5) << theTrack->GetCurrentStepNumber() << "  "
	<< std::setw(6) << G4BestUnit(theTrack->GetPosition().x(),"Length") << "  "
	<< std::setw(6) << G4BestUnit(theTrack->GetPosition().y(),"Length") << "  "
	<< std::setw(6) << G4BestUnit(theTrack->GetPosition().z(),"Length") << "  "
	<< std::setw(6) << G4BestUnit(theTrack->GetKineticEnergy(),"Energy") << "  "
	<< std::setw(6) << G4BestUnit(theStep->GetTotalEnergyDeposit(),"Energy") << "  "
	<< std::setw(6) << G4BestUnit(theStep->GetStepLength(),"Length") << "  "
	<< std::setw(6) << G4BestUnit(theTrack->GetTrackLength(),"Length") << "  ";
	if(theStep->GetPostStepPoint()->GetProcessDefinedStep() != 0){
	G4cout << "  " << std::setw(6) << theStep->GetPostStepPoint()->GetProcessDefinedStep()
	->GetProcessName() << G4endl;
	} 
	else {
		G4cout << "   UserLimit";
	}  	
}


